Index: issm/trunk/src/c/shared/Elements/PrintArrays.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/PrintArrays.cpp	(revision 13395)
+++ issm/trunk/src/c/shared/Elements/PrintArrays.cpp	(revision 13395)
@@ -0,0 +1,33 @@
+
+#include "./elements.h"
+#include "../../include/macros.h"
+using namespace std;
+
+void printarray(IssmPDouble* array,int lines,int cols){
+	_printLine_("");
+	for(int i=0;i<lines;i++){  
+		_printString_("   [ ");
+		for(int j=0;j<cols;j++) _printString_( " " << setw(11) << setprecision (5) << array[i*cols+j]);
+		_printLine_(" ]");
+	}  
+	_printLine_("");
+}
+void printarray(int* array,int lines,int cols){
+	_printLine_("");
+	for(int i=0;i<lines;i++){  
+		_printString_("   [ ");
+		for(int j=0;j<cols;j++) _printString_( " " << setw(11) << setprecision (5) << array[i*cols+j]);
+		_printLine_(" ]");
+	}  
+	_printLine_("");
+}
+void printbinary(int n){
+	unsigned int i=1L<<(sizeof(n)*8-1);
+	while (i>0) {
+		if (n&i)
+		 _printString_("1");
+		else
+		 _printString_("0");
+		i>>=1;
+	}
+}
Index: issm/trunk/src/c/shared/Elements/TransformInvStiffnessMatrixCoord.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/TransformInvStiffnessMatrixCoord.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Elements/TransformInvStiffnessMatrixCoord.cpp	(revision 13395)
@@ -31,5 +31,5 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
+			default: _error_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
Index: issm/trunk/src/c/shared/Elements/TransformLoadVectorCoord.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/TransformLoadVectorCoord.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Elements/TransformLoadVectorCoord.cpp	(revision 13395)
@@ -30,5 +30,5 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
+			default: _error_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
Index: issm/trunk/src/c/shared/Elements/TransformSolutionCoord.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/TransformSolutionCoord.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Elements/TransformSolutionCoord.cpp	(revision 13395)
@@ -31,5 +31,5 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
+			default: _error_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
Index: issm/trunk/src/c/shared/Elements/TransformStiffnessMatrixCoord.cpp
===================================================================
--- issm/trunk/src/c/shared/Elements/TransformStiffnessMatrixCoord.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Elements/TransformStiffnessMatrixCoord.cpp	(revision 13395)
@@ -31,5 +31,5 @@
 			case XYEnum:   numdofs+=2; break;
 			case XYZPEnum: numdofs+=4; break;
-			default: _error2_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
+			default: _error_("Coordinate system " << EnumToStringx(cs_array[i]) << " not supported yet");
 		}
 	}
Index: issm/trunk/src/c/shared/Elements/elements.h
===================================================================
--- issm/trunk/src/c/shared/Elements/elements.h	(revision 12709)
+++ issm/trunk/src/c/shared/Elements/elements.h	(revision 13395)
@@ -4,7 +4,7 @@
 
 #ifndef _SHARED_ELEMENTS_H_
-#define  _SHARED_ELEMENTS_H_
+#define _SHARED_ELEMENTS_H_
 
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../Container/Container.h"
 class ElementMatrix;
@@ -13,9 +13,16 @@
 IssmDouble Paterson(IssmDouble temperature);
 IssmDouble Arrhenius(IssmDouble temperature,IssmDouble depth,IssmDouble n);
-IssmDouble PddSurfaceMassBlance(IssmDouble* monthlytemperatures,  IssmDouble* monthlyprec, IssmDouble* pdds, IssmDouble* pds, IssmDouble signorm, IssmDouble yts, IssmDouble h, IssmDouble s, IssmDouble rho_ice, IssmDouble rho_water);
+IssmDouble PddSurfaceMassBlance(IssmDouble* monthlytemperatures,  IssmDouble* monthlyprec, IssmDouble* pdds, IssmDouble* pds, 
+				IssmDouble signorm, IssmDouble yts, IssmDouble h, IssmDouble s, IssmDouble rho_ice, IssmDouble rho_water);
+void ComputeDelta18oTemperaturePrecipitation(IssmDouble Delta18oSurfacePresent, IssmDouble Delta18oSurfaceLgm, IssmDouble Delta18oSurfaceTime,
+				     IssmDouble Delta18oPresent, IssmDouble Delta18oLgm, IssmDouble Delta18oTime, 
+				     IssmDouble* PrecipitationsPresentday,
+				     IssmDouble* TemperaturesLgm, IssmDouble* TemperaturesPresentday, 
+					     IssmDouble* monthlytemperaturesout, IssmDouble* monthlyprecout);
 void   GetVerticesCoordinates(IssmDouble* xyz,  Node** nodes, int numvertices);
 int    GetNumberOfDofs( Node** nodes,int numnodes,int setenum,int approximation_enum);
 int*   GetLocalDofList( Node** nodes,int numnodes,int setenum,int approximation_enum);
 int*   GetGlobalDofList(Node** nodes,int numnodes,int setenum,int approximation_enum);
+
 #ifdef _HAVE_DIAGNOSTIC_
 void   CoordinateSystemTransform(IssmDouble** ptransform,Node** nodes,int numnodes,int* cs_array);
@@ -30,32 +37,7 @@
 #endif
 
-inline void printarray(IssmPDouble* array,int lines,int cols=1){
-	_printLine_("");
-	for(int i=0;i<lines;i++){  
-		_printString_("   [ ");
-		for(int j=0;j<cols;j++) _printString_( " " << setw(11) << setprecision (5) << array[i*cols+j]);
-		_printLine_(" ]");
-	}  
-	_printLine_("");
-}
-inline void printarray(int* array,int lines,int cols=1){
-	_printLine_("");
-	for(int i=0;i<lines;i++){  
-		_printString_("   [ ");
-		for(int j=0;j<cols;j++) _printString_( " " << setw(11) << setprecision (5) << array[i*cols+j]);
-		_printLine_(" ]");
-	}  
-	_printLine_("");
-}
-inline void printbinary(int n) {
-	unsigned int i=1L<<(sizeof(n)*8-1);
-	while (i>0) {
-		if (n&i)
-		 _printString_("1");
-		else
-		 _printString_("0");
-		i>>=1;
-	}
-}
-
+/*Print arrays*/
+void printarray(IssmPDouble* array,int lines,int cols=1);
+void printarray(int* array,int lines,int cols=1);
+void printbinary(int n);
 #endif //ifndef _SHARED_ELEMENTS_H_
Index: issm/trunk/src/c/shared/Exceptions/Exceptions.cpp
===================================================================
--- issm/trunk/src/c/shared/Exceptions/Exceptions.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Exceptions/Exceptions.cpp	(revision 13395)
@@ -39,5 +39,5 @@
 }
 
-void ErrorException::Report(){
+void ErrorException::Report() const{
 	extern int my_rank;
 	extern int num_procs;
Index: issm/trunk/src/c/shared/Exceptions/exceptions.h
===================================================================
--- issm/trunk/src/c/shared/Exceptions/exceptions.h	(revision 12709)
+++ issm/trunk/src/c/shared/Exceptions/exceptions.h	(revision 13395)
@@ -27,5 +27,5 @@
 	~ErrorException() throw();
 	virtual const char *what() const throw();
-	void Report();
+	void Report() const;
 
 };
Index: issm/trunk/src/c/shared/Exp/DomainOutlineWrite.cpp
===================================================================
--- issm/trunk/src/c/shared/Exp/DomainOutlineWrite.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Exp/DomainOutlineWrite.cpp	(revision 13395)
@@ -12,5 +12,4 @@
 
 int DomainOutlineWrite(int nprof,int* profnvertices,double** pprofx,double** pprofy,bool* closed,char* domainname){
-
 	
 	/*Error management: */
@@ -23,5 +22,5 @@
 	/*open domain outline file for writing: */
 	if ((fid=fopen(domainname,"w"))==NULL){
-		_error2_("could not open domain file " << domainname); 
+		_error_("could not open domain file " << domainname); 
 		noerr=0; goto cleanupandreturn;
 	}
@@ -56,3 +55,2 @@
 	return noerr;
 }
-
Index: issm/trunk/src/c/shared/Exp/IsInPoly.cpp
===================================================================
--- issm/trunk/src/c/shared/Exp/IsInPoly.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Exp/IsInPoly.cpp	(revision 13395)
@@ -14,86 +14,4 @@
 #endif
 
-/*IsInPoly {{{*/
-int IsInPoly(Vector* in,double* xc,double* yc,int numvertices,double* x,double* y,int i0,int i1, int edgevalue){
-
-	int i;
-	double x0,y0;
-	double value;
-	double xmin=xc[0];
-	double xmax=xc[0];
-	double ymin=yc[0];
-	double ymax=yc[0];
-
-	/*Get extrema*/
-	for (i=1;i<numvertices;i++){
-		if(xc[i]<xmin) xmin=xc[i];
-		if(xc[i]>xmax) xmax=xc[i];
-		if(yc[i]<ymin) ymin=yc[i];
-		if(yc[i]>ymax) ymax=yc[i];
-	}
-
-	/*Go through all vertices of the mesh:*/
-	for (i=i0;i<i1;i++){
-
-		//Get current value of value[i] -> do not change it if != 0
-		in->GetValue(&value,i);
-		if (value){
-			/*this vertex already is inside one of the contours, continue*/
-			continue;
-		}
-
-		/*pick up vertex (x[i],y[i]) and figure out if located inside contour (xc,yc)*/
-		x0=x[i]; y0=y[i];
-		if(x0<xmin || x0>xmax || y0<ymin || y0>ymax){
-			value=0;
-		}
-		else{
-			value=pnpoly(numvertices,xc,yc,x0,y0,edgevalue);
-		}
-		in->SetValue(i,value,INS_VAL);
-	}
-	 return 1;
-}/*}}}*/
-/*IsOutsidePoly {{{*/
-int IsOutsidePoly(Vector* in,double* xc,double* yc,int numvertices,double* x,double* y,int i0,int i1, int edgevalue){
-
-	int i,j;
-	double x0,y0;
-	double value;
-	double xmin=xc[0];
-	double xmax=xc[0];
-	double ymin=yc[0];
-	double ymax=yc[0];
-
-	/*Get extrema*/
-	for (i=1;i<numvertices;i++){
-		if(xc[i]<xmin) xmin=xc[i];
-		if(xc[i]>xmax) xmax=xc[i];
-		if(yc[i]<ymin) ymin=yc[i];
-		if(yc[i]>ymax) ymax=yc[i];
-	}
-
-	/*Go through all vertices of the mesh:*/
-	for (i=i0;i<i1;i++){
-
-		//Get current value of value[i] -> do not change it if != 0
-		in->GetValue(&value,i);
-		if (value){
-			/*this vertex already is inside one of the contours, continue*/
-			continue;
-		}
-
-		/*pick up vertex (x[i],y[i]) and figure out if located inside contour (xc,yc)*/
-		x0=x[i]; y0=y[i];
-		if(x0<xmin || x0>xmax || y0<ymin || y0>ymax){
-			value=1;
-		}
-		else{
-			value=1-pnpoly(numvertices,xc,yc,x0,y0,edgevalue);
-		}
-		in->SetValue(i,value,INS_VAL);
-	}
-	return 1;
-}/*}}}*/
 /*pnpoly{{{*/
 int pnpoly(int npol, double *xp, double *yp, double x, double y, int edgevalue) {
Index: issm/trunk/src/c/shared/Exp/IsInPolySerial.cpp
===================================================================
--- issm/trunk/src/c/shared/Exp/IsInPolySerial.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Exp/IsInPolySerial.cpp	(revision 13395)
@@ -24,8 +24,8 @@
 		y0=y[i];
 		if (pnpoly(numvertices,xc,yc,x0,y0,edgevalue)){
-			in[i]=1;
+			in[i]=1.;
 		}
 		else{
-			in[i]=0;
+			in[i]=0.;
 		}
 	}
Index: issm/trunk/src/c/shared/Exp/exp.h
===================================================================
--- issm/trunk/src/c/shared/Exp/exp.h	(revision 12709)
+++ issm/trunk/src/c/shared/Exp/exp.h	(revision 13395)
@@ -3,20 +3,192 @@
  */
 
-
 #ifndef _EXP_H_
 #define _EXP_H_
 
-#include "../../objects/objects.h"
-#include "../../toolkits/toolkits.h"
+#include <cstring>
+#include "../../classes/objects/Contour.h"
+#include "../../shared/Numerics/recast.h"
+#include "../../Container/Container.h"
 
-int IsInPoly(Vector* in,double* xc,double* yc,int numvertices,double* x,double* y,int i0,int i1, int edgevalue);
-int IsOutsidePoly(Vector* in,double* xc,double* yc,int numvertices,double* x,double* y,int i0,int i1, int edgevalue);
 int IsInPolySerial(double* in,double* xc,double* yc,int numvertices,double* x,double* y,int nods, int edgevalue);
 int DomainOutlineWrite(int nprof,int* profnvertices,double** pprofx,double** pprofy,bool* closed,char* domainname);
 int pnpoly(int npol, double *xp, double *yp, double x, double y, int edgevalue);
 
-int      DomainOutlineRead(int* pnprof,int** pprofnvertices,double*** ppprofx,double*** ppprofy,bool** pclosed,char* domainname);
-DataSet* DomainOutlineRead(char* domainname);
+/*IsInPoly {{{*/
+template <class doubletype>
+int IsInPoly(SeqVec<doubletype>* in,double* xc,double* yc,int numvertices,double* x,double* y,int i0,int i1, int edgevalue){
 
+	int i;
+	double x0,y0;
+	doubletype value;
+	double xmin=xc[0];
+	double xmax=xc[0];
+	double ymin=yc[0];
+	double ymax=yc[0];
+
+	/*Get extrema*/
+	for (i=1;i<numvertices;i++){
+		if(xc[i]<xmin) xmin=xc[i];
+		if(xc[i]>xmax) xmax=xc[i];
+		if(yc[i]<ymin) ymin=yc[i];
+		if(yc[i]>ymax) ymax=yc[i];
+	}
+
+	/*Go through all vertices of the mesh:*/
+	for (i=i0;i<i1;i++){
+
+		//Get current value of value[i] -> do not change it if != 0
+		in->GetValue(&value,i);
+		if (reCast<bool,doubletype>(value)){
+			/*this vertex already is inside one of the contours, continue*/
+			continue;
+		}
+
+		/*pick up vertex (x[i],y[i]) and figure out if located inside contour (xc,yc)*/
+		x0=x[i]; y0=y[i];
+		if(x0<xmin || x0>xmax || y0<ymin || y0>ymax){
+			value=0;
+		}
+		else{
+			value=pnpoly(numvertices,xc,yc,x0,y0,edgevalue);
+		}
+		in->SetValue(i,value,INS_VAL);
+	}
+	 return 1;
+}/*}}}*/
+/*DomainOutlineRead{{{*/
+template <class doubletype>
+int DomainOutlineRead(int* pnprof,int** pprofnvertices,doubletype*** ppprofx,doubletype*** ppprofy,bool** pclosed,char* domainname){
+	
+	/*indexing: */
+	int i,counter;
+
+	/*I/O: */
+	FILE   *fid = NULL;
+	char    chardummy[256];
+	double  ddummy;
+
+	/*output: */
+	int          nprof;                //number of profiles in the domainname file
+	int         *profnvertices = NULL; //array holding the number of vertices for the nprof profiles
+	doubletype **pprofx        = NULL; //array of profiles x coordinates
+	doubletype **pprofy        = NULL; //array of profiles y coordinates
+	bool        *closed        = NULL; //array holding closed flags for the nprof profiles
+
+	/*For each profile: */
+	int         n;
+	doubletype *x  = NULL;
+	doubletype *y  = NULL;
+	bool        cl;
+
+	/*open domain outline file for reading: */
+	if ((fid=fopen(domainname,"r"))==NULL){
+		_error_("could not find domain file " << domainname); 
+	}
+
+	/*Do a first pass through the domainname file, to figure out how many profiles we need to read: */
+	nprof=1;
+	for(;;){
+		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
+		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
+		fscanf(fid,"%256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy);
+		fscanf(fid,"%20u %256s\n",&n,chardummy);
+		fscanf(fid,"%256s %256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy,chardummy);
+		for (i=0;i<n;i++) fscanf(fid,"%20lf %20lf\n",&ddummy,&ddummy);
+		/*check whether we are at the end of the file, otherwise, keep reading next profile:*/
+		if (feof(fid)) break;
+		nprof++;
+	}
+	
+	/*Allocate and initialize all the profiles: */
+	profnvertices = xNew<int>(nprof);
+	pprofx        = xNew<doubletype*>(nprof);
+	pprofy        = xNew<doubletype*>(nprof);
+	for (i=0;i<nprof;i++){
+		pprofx[i] = NULL;
+		pprofy[i] = NULL;
+	}
+	closed=xNew<bool>(nprof);
+
+	/*Reaset file pointer to beginning of file: */
+	fseek(fid,0,SEEK_SET);
+
+	/*Start reading profiles: */
+	for(counter=0;counter<nprof;counter++){
+
+		/*Skip header: */
+		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
+		fscanf(fid,"%256s %256s\n",chardummy,chardummy);
+		fscanf(fid,"%256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy);
+		
+		/*Get number of profile vertices: */
+		fscanf(fid,"%20u %256s\n",&n,chardummy);
+	
+		/*Skip next line: */
+		fscanf(fid,"%256s %256s %256s %256s %256s\n",chardummy,chardummy,chardummy,chardummy,chardummy);
+
+		/*Allocate vertices: */
+		x=xNew<doubletype>(n);
+		y=xNew<doubletype>(n);
+		
+		/*Read vertices: */
+		for (i=0;i<n;i++){
+			fscanf(fid,"%20lf %20lf\n",&x[i],&y[i]);
+		}
+
+		/*Now check that we are dealing with open contours: */
+		cl=false;
+		if((x[0]==x[n-1]) && (y[0]==y[n-1])){
+			cl=true;
+		}
+
+		/*Assign pointers: */
+		profnvertices[counter]=n;
+		pprofx[counter]=x;
+		pprofy[counter]=y;
+		closed[counter]=cl;
+	}
+
+	/*close domain outline file: */
+	fclose(fid);
+
+	/*Assign output pointers: */
+	*pnprof=nprof;
+	*pprofnvertices=profnvertices;
+	*ppprofx=pprofx;
+	*ppprofy=pprofy;
+	if(pclosed) *pclosed=closed;
+	else         xDelete<bool>(closed);
+} /*}}}*/
+/*DataSet* DomainOutlineRead(char* domainname){{{*/
+template <class doubletype>
+DataSet* DomainOutlineRead(char* domainname){
+
+	/*intermediary: */
+	int                  nprof;
+	int                 *profnvertices = NULL;
+	doubletype         **pprofx        = NULL;
+	doubletype         **pprofy        = NULL;
+	Contour<doubletype> *contour       = NULL;
+
+	/*output: */
+	DataSet *domain = NULL;
+
+	/*If domainname is an empty string, return empty dataset*/
+	if (strcmp(domainname,"")==0){
+		nprof=0;
+	}
+	else{
+		DomainOutlineRead(&nprof,&profnvertices,&pprofx, &pprofy, NULL,domainname);
+	}
+
+	/*now create dataset of contours: */
+	domain=new DataSet(0);
+
+	for(int i=0;i<nprof;i++){
+		domain->AddObject(new Contour<doubletype>(i,profnvertices[i],pprofx[i],pprofy[i],1));
+	}
+	return domain;
+} /*}}}*/
 
 #endif
Index: issm/trunk/src/c/shared/Matrix/MatrixUtils.cpp
===================================================================
--- issm/trunk/src/c/shared/Matrix/MatrixUtils.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Matrix/MatrixUtils.cpp	(revision 13395)
@@ -17,55 +17,46 @@
 
 /*FUNCTION TripleMultiply {{{*/
-int TripleMultiply( IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int nrowc, int ncolc, int itrnc, IssmDouble* d, int iaddd){
+int TripleMultiply(IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int nrowc, int ncolc, int itrnc, IssmDouble* d, int iaddd){
 	/*TripleMultiply    Perform triple matrix product a*b*c+d.*/
-	
-	int idima,idimb,idimc,idimd;
-	IssmDouble* dtemp;
-
-/*  set up dimensions for triple product  */
-
-	if (!itrna) {
+
+	int         idima,idimb,idimc,idimd;
+	IssmDouble *dtemp;
+
+	/*  set up dimensions for triple product  */
+
+	if (!itrna){
 		idima=nrowa;
 		idimb=ncola;
 	}
-	else {
+	else{
 		idima=ncola;
 		idimb=nrowa;
 	}
 
-	if (!itrnb) {
-		if (nrowb != idimb) {
-			_error2_("Matrix A and B inner vectors not equal size.");
-		}
+	if (!itrnb){
+		if (nrowb != idimb) _error_("Matrix A and B inner vectors not equal size.");
 		idimc=ncolb;
 	}
-	else {
-		if (ncolb != idimb) {
-			_error2_("Matrix A and B inner vectors not equal size.");
-		}
+	else{
+		if (ncolb != idimb) _error_("Matrix A and B inner vectors not equal size.");
 		idimc=nrowb;
 	}
 
 	if (!itrnc) {
-		if (nrowc != idimc) {
-			_error2_("Matrix B and C inner vectors not equal size.");
-		}
+		if (nrowc != idimc) _error_("Matrix B and C inner vectors not equal size.");
 		idimd=ncolc;
 	}
-	else {
-		if (ncolc != idimc) {
-			_error2_("Matrix B and C inner vectors not equal size.");
-		}
+	else{
+		if (ncolc != idimc) _error_("Matrix B and C inner vectors not equal size.");
 		idimd=nrowc;
 	}
 
-/*  perform the matrix triple product in the order that minimizes the
-	number of multiplies and the temporary space used, noting that
-	(a*b)*c requires ac(b+d) multiplies and ac IssmDoubles, and a*(b*c)
-	requires bd(a+c) multiplies and bd IssmDoubles (both are the same for
-	a symmetric triple product)  */
-
-/*  multiply (a*b)*c+d  */
-
+	/*  perform the matrix triple product in the order that minimizes the
+		 number of multiplies and the temporary space used, noting that
+		 (a*b)*c requires ac(b+d) multiplies and ac IssmDoubles, and a*(b*c)
+		 requires bd(a+c) multiplies and bd IssmDoubles (both are the same for
+		 a symmetric triple product)  */
+
+	/*  multiply (a*b)*c+d  */
 	if (idima*idimc*(idimb+idimd) <= idimb*idimd*(idima+idimc)) {
 		dtemp=xNew<IssmDouble>(idima*idimc);
@@ -76,7 +67,6 @@
 	}
 
-/*  multiply a*(b*c)+d  */
-
-	else {
+	/*  multiply a*(b*c)+d  */
+	else{
 		dtemp=xNew<IssmDouble>(idimb*idimd);
 
@@ -89,5 +79,5 @@
 }/*}}}*/
 /*FUNCTION MatrixMuliply {{{*/
-int MatrixMultiply( IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int iaddc ){
+int MatrixMultiply(IssmDouble* a, int nrowa, int ncola, int itrna, IssmDouble* b, int nrowb, int ncolb, int itrnb, IssmDouble* c, int iaddc ){
 	/*MatrixMultiply    Perform matrix multiplication a*b+c.*/
 	int noerr=1;
@@ -95,5 +85,5 @@
 	int nrowc,ncolc,iinca,jinca,iincb,jincb,ntrma,ntrmb,nterm;
 
-/*  set up dimensions and increments for matrix a  */
+	/*  set up dimensions and increments for matrix a  */
 	if (!itrna) {
 		nrowc=nrowa;
@@ -109,5 +99,5 @@
 	}
 
-/*  set up dimensions and increments for matrix b  */
+	/*  set up dimensions and increments for matrix b  */
 	if (!itrnb) {
 		ncolc=ncolb;
@@ -123,32 +113,23 @@
 	}
 
-	if (ntrma != ntrmb) {
-		_error2_("Matrix A and B inner vectors not equal size");
-	    noerr=0;	
-		return noerr;
-	}
-	else
-		nterm=ntrma;
-
-/*  zero matrix c, if not being added to product  */
-
-	if (!iaddc)
-		for (i=0; i<nrowc*ncolc; i++)
-			*(c+i)=0.;
-
-/*  perform the matrix multiplication  */
-
+	if (ntrma != ntrmb) _error_("Matrix A and B inner vectors not equal size");
+
+	nterm=ntrma;
+
+	/*  zero matrix c, if not being added to product  */
+	if (!iaddc) for (i=0;i<nrowc*ncolc;i++) c[i]=0.;
+
+	/*  perform the matrix multiplication  */
 	iptc=0;
-	for (i=0; i<nrowc; i++) {
-		for (j=0; j<ncolc; j++) {
+	for (i=0; i<nrowc; i++){
+		for (j=0; j<ncolc; j++){
 			ipta=i*iinca;
 			iptb=j*jincb;
 
-			for (k=0; k<nterm; k++) {
-				*(c+iptc)+=*(a+ipta)**(b+iptb);
+			for (k=0; k<nterm; k++){
+				c[iptc]+=a[ipta]*b[iptb];
 				ipta+=jinca;
 				iptb+=iincb;
 			}
-
 			iptc++;
 		}
@@ -159,14 +140,14 @@
 /*FUNCTION MatrixInverse {{{*/
 int MatrixInverse( IssmDouble* a, int ndim, int nrow, IssmDouble* b, int nvec, IssmDouble* pdet ){
-/* MatrixInverse    Perform matrix inversion and linear equation solution.
-
-	This function uses Gaussian elimination on the original matrix
-	augmented by an identity matrix of the same size to calculate
-	the inverse (see for example, "Modern Methods of Engineering
-	Computation", Sec. 6.4).  By noting how the matrices are
-	unpopulated and repopulated, the calculation may be done in place.
-
-	Gaussian elimination is inherently inefficient, and so this is
-	intended for small matrices.  */
+	/* MatrixInverse    Perform matrix inversion and linear equation solution.
+
+		This function uses Gaussian elimination on the original matrix
+		augmented by an identity matrix of the same size to calculate
+		the inverse (see for example, "Modern Methods of Engineering
+		Computation", Sec. 6.4).  By noting how the matrices are
+		unpopulated and repopulated, the calculation may be done in place.
+
+		Gaussian elimination is inherently inefficient, and so this is
+		intended for small matrices.  */
 	int noerr=1;
 	int i,j,k,ipt,jpt,irow,icol,ipiv,ncol;
@@ -175,5 +156,5 @@
 
 	if (!b && nvec) {
-		_error2_("No right-hand side for nvec=" << nvec << ".");
+		_error_("No right-hand side for nvec=" << nvec << ".");
 		noerr=0;
 		return noerr;
@@ -184,5 +165,5 @@
 	_assert_(!(ndim==3 && nrow==3));
 
-/*  initialize local variables and arrays  */
+	/*  initialize local variables and arrays  */
 
 	ncol=nrow;
@@ -192,21 +173,21 @@
 	pindx =xNew<int>(nrow);
 
-/*  loop over the rows/columns of the matrix  */
+	/*  loop over the rows/columns of the matrix  */
 
 	for (i=0; i<nrow; i++) {
 
-/*  search for pivot, finding the term with the greatest magnitude
-	in the rows/columns not yet used  */
+		/*  search for pivot, finding the term with the greatest magnitude
+			 in the rows/columns not yet used  */
 
 		pivot=0.;
 		for (j=0; j<nrow; j++)
-			if (!pindx[j])
-				for (k=0; k<ncol; k++)
-					if (!pindx[k])
-						if (fabs(a[j*ndim+k]) > fabs(pivot)) {
-							irow=j;
-							icol=k;
-							pivot=a[j*ndim+k];
-						}
+		 if (!pindx[j])
+		  for (k=0; k<ncol; k++)
+			if (!pindx[k])
+			 if (fabs(a[j*ndim+k]) > fabs(pivot)) {
+				 irow=j;
+				 icol=k;
+				 pivot=a[j*ndim+k];
+			 }
 
 		if (fabs(pivot) < DBL_EPSILON) {
@@ -214,5 +195,5 @@
 			xDelete<int>(pivrc2);
 			xDelete<int>(pindx);
-			_error2_("Pivot " << pivot << " less than machine epsilon");
+			_error_("Pivot " << pivot << " less than machine epsilon");
 			noerr=0;
 			return noerr;
@@ -225,13 +206,13 @@
 		pindx[ipiv]++;
 
-//		_printf_(true,"pivot for i=%d: irow=%d, icol=%d, pindx[%d]=%d\n",
-//				 i,irow,icol,ipiv,pindx[ipiv]);
-
-/*  switch rows to put pivot element on diagonal, noting that the
-	column stays the same and the determinant changes sign  */
+		//		_printf_(true,"pivot for i=%d: irow=%d, icol=%d, pindx[%d]=%d\n",
+		//				 i,irow,icol,ipiv,pindx[ipiv]);
+
+		/*  switch rows to put pivot element on diagonal, noting that the
+			 column stays the same and the determinant changes sign  */
 
 		if (irow != icol) {
-//			_printf_(true,"row switch for i=%d: irow=%d, icol=%d\n",
-//					 i,irow,icol);
+			//			_printf_(true,"row switch for i=%d: irow=%d, icol=%d\n",
+			//					 i,irow,icol);
 
 			ipt=irow*ndim;
@@ -254,8 +235,8 @@
 		}
 
-/*  divide pivot row by pivot element, noting that the original
-	matrix will have 1 on the diagonal, which will be discarded,
-	and the augmented matrix will start with 1 from the identity
-	matrix and then have 1/pivot, which is part of the inverse.  */
+		/*  divide pivot row by pivot element, noting that the original
+			 matrix will have 1 on the diagonal, which will be discarded,
+			 and the augmented matrix will start with 1 from the identity
+			 matrix and then have 1/pivot, which is part of the inverse.  */
 
 		a[ipiv*ndim+ipiv]=1.;
@@ -263,17 +244,17 @@
 		ipt=ipiv*ndim;
 		for (k=0; k<ncol; k++)
-			a[ipt+k]/=pivot;
+		 a[ipt+k]/=pivot;
 
 		ipt=ipiv*nvec;
 		for (k=0; k<nvec; k++)
-			b[ipt+k]/=pivot;
-
-/*  reduce non-pivot rows such that they will have 0 in the pivot
-	column, which will be discarded, and the augmented matrix will
-	start with 0 from the identity matrix and then have non-zero
-	in the corresponding column, which is part of the inverse.
-	only one column of the augmented matrix is populated at a time,
-	which corresponds to the only column of the original matrix
-	being zeroed, so that the inverse may be done in place.  */
+		 b[ipt+k]/=pivot;
+
+		/*  reduce non-pivot rows such that they will have 0 in the pivot
+			 column, which will be discarded, and the augmented matrix will
+			 start with 0 from the identity matrix and then have non-zero
+			 in the corresponding column, which is part of the inverse.
+			 only one column of the augmented matrix is populated at a time,
+			 which corresponds to the only column of the original matrix
+			 being zeroed, so that the inverse may be done in place.  */
 
 		for (j=0; j<nrow; j++) {
@@ -287,23 +268,23 @@
 				jpt=ipiv*ndim;
 				for (k=0; k<ncol; k++)
-					a[ipt+k]-=dtemp*a[jpt+k];
+				 a[ipt+k]-=dtemp*a[jpt+k];
 
 				ipt=j   *nvec;
 				jpt=ipiv*nvec;
 				for (k=0; k<nvec; k++)
-					b[ipt+k]-=dtemp*b[jpt+k];
-			}
-		}
-
-/*  for a diagonal matrix, the determinant is the product of the
-	diagonal terms, and so it may be accumulated from the pivots,
-	noting that switching rows changes the sign as above  */
+				 b[ipt+k]-=dtemp*b[jpt+k];
+			}
+		}
+
+		/*  for a diagonal matrix, the determinant is the product of the
+			 diagonal terms, and so it may be accumulated from the pivots,
+			 noting that switching rows changes the sign as above  */
 
 		det*=pivot;
 	}
 
-/*  switch columns back in reverse order, noting that a row switch
-	in the original matrix corresponds to a column switch in the
-	inverse matrix  */
+	/*  switch columns back in reverse order, noting that a row switch
+		 in the original matrix corresponds to a column switch in the
+		 inverse matrix  */
 
 	for (i=0; i<nrow; i++) {
@@ -314,6 +295,6 @@
 			icol=pivrc2[j];
 
-//			_printf_(true,"column switch back for j=%d: irow=%d, icol=%d\n",
-//					 j,irow,icol);
+			//			_printf_(true,"column switch back for j=%d: irow=%d, icol=%d\n",
+			//					 j,irow,icol);
 
 			ipt=0;
@@ -349,5 +330,5 @@
 	/*Compute determinant*/
 	Matrix2x2Determinant(&det,A);
-	if (fabs(det) < DBL_EPSILON) _error2_("Determinant smaller that machine epsilon");
+	if (fabs(det) < DBL_EPSILON) _error_("Determinant smaller that machine epsilon");
 
 	/*Compute invert*/
@@ -363,5 +344,5 @@
 
 	/*det = a*(e*i-f*h)-b*(d*i-f*g)+c*(d*h-e*g)*/
-   *Adet= A[0]*A[4]*A[8]-A[0]*A[5]*A[7]-A[3]*A[1]*A[8]+A[3]*A[2]*A[7]+A[6]*A[1]*A[5]-A[6]*A[2]*A[4];
+	*Adet= A[0]*A[4]*A[8]-A[0]*A[5]*A[7]-A[3]*A[1]*A[8]+A[3]*A[2]*A[7]+A[6]*A[1]*A[5]-A[6]*A[2]*A[4];
 }
 /*}}}*/
@@ -374,5 +355,5 @@
 	/*Compute determinant*/
 	Matrix3x3Determinant(&det,A);
-	if (fabs(det) < DBL_EPSILON) _error2_("Determinant smaller that machine epsilon");
+	if (fabs(det) < DBL_EPSILON) _error_("Determinant smaller that machine epsilon");
 
 	/*Compute invert*/
Index: issm/trunk/src/c/shared/Numerics/BrentSearch.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/BrentSearch.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/BrentSearch.cpp	(revision 13395)
@@ -10,5 +10,5 @@
 
 #include "./numerics.h"
-#include "../../objects/objects.h"
+#include "../../classes/objects/objects.h"
 #include "../../include/include.h"
 #include "../../io/io.h"
@@ -44,5 +44,5 @@
 	iter=0;
 	fxmin = (*f)(xmin,optargs);
-	if (xIsNan<IssmDouble>(fxmin)) _error2_("Function evaluation returned NaN");
+	if (xIsNan<IssmDouble>(fxmin)) _error_("Function evaluation returned NaN");
 	cout<<setprecision(5);
 	if(VerboseControl()) _pprintLine_("");
@@ -51,5 +51,5 @@
 	if(VerboseControl()) _pprintLine_("           N/A    "<<setw(12)<<xmin<<"  "<<setw(12)<<fxmin<<"           N/A         boundary");
 	fxmax = (*f)(xmax,optargs);
-	if (xIsNan<IssmDouble>(fxmax)) _error2_("Function evaluation returned NaN");
+	if (xIsNan<IssmDouble>(fxmax)) _error_("Function evaluation returned NaN");
 	if(VerboseControl()) _pprintLine_("           N/A    "<<setw(12)<<xmax<<"  "<<setw(12)<<fxmax<<"           N/A         boundary");
 
@@ -75,5 +75,5 @@
 	/*2: call the function to be evaluated*/
 	fxbest = (*f)(x,optargs);
-	if(xIsNan<IssmDouble>(fxbest)) _error2_("Function evaluation returned NaN");
+	if(xIsNan<IssmDouble>(fxbest)) _error_("Function evaluation returned NaN");
 	iter=iter+1;
 
@@ -159,5 +159,5 @@
 		//evaluate function on x
 		fx = (*f)(x,optargs);
-		if(xIsNan<IssmDouble>(fx)) _error2_("Function evaluation returned NaN");
+		if(xIsNan<IssmDouble>(fx)) _error_("Function evaluation returned NaN");
 		iter=iter+1;
 
Index: issm/trunk/src/c/shared/Numerics/GaussPoints.cpp
===================================================================
--- issm/trunk/src/c/shared/Numerics/GaussPoints.cpp	(revision 12709)
+++ issm/trunk/src/c/shared/Numerics/GaussPoints.cpp	(revision 13395)
@@ -4,5 +4,4 @@
 #include "./GaussPoints.h"
 #include "../Alloc/alloc.h"
-#include "../../io/io.h"
 #include "../Exceptions/exceptions.h"
 #include <math.h>
@@ -1670,5 +1669,5 @@
 		if (iter >= MAX_GAUS_ITER) {
 			xDelete<IssmPDouble>(work);
-			_error2_("Max iterations exceeded for l=" << MAX_GAUS_ITER);
+			_error_("Max iterations exceeded for l=" << MAX_GAUS_ITER);
 		}
 	}
